# Code generated by lark suite oapi sdk gen

from typing import *

from ....api import (
    Request as APIRequest,
    set_timeout,
    set_tenant_key,
)
from ....consts import (
    ACCESS_TOKEN_TYPE_TENANT,
)
from .model import *


class Service:
    def __init__(self, conf):
        # type: (Config) -> None
        self.conf = conf
        self.tenants = TenantService(self)


class TenantService:
    def __init__(self, service):
        # type: (Service) -> None
        self.service = service

    def query(self, tenant_key=None, timeout=None):
        # type: (str, int) -> TenantQueryReqCall

        request_opts = []  # type: List[Callable[[Any], Any]]

        if timeout is not None:
            request_opts += [set_timeout(timeout)]

        if tenant_key is not None:
            request_opts += [set_tenant_key(tenant_key)]

        return TenantQueryReqCall(self, request_opts=request_opts)


class TenantQueryReqCall:
    def __init__(self, service, request_opts=None):
        # type: (TenantService, List[Any]) -> None

        self.service = service

        if request_opts:
            self.request_opts = request_opts
        else:
            self.request_opts = []  # type: List[Any]

    def do(self):
        # type: () -> APIResponse[Type[TenantQueryResult]]
        root_service = self.service.service

        conf = root_service.conf
        req = APIRequest(
            "/open-apis/tenant/v2/tenant/query",
            "GET",
            [ACCESS_TOKEN_TYPE_TENANT],
            None,
            output_class=TenantQueryResult,
            request_opts=self.request_opts,
        )
        resp = req.do(conf)
        return resp
